<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: Admin Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_admin.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="class_admin-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Admin Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A library user who is also an admin (i.e can manage books of library)  
 <a href="class_admin.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_admin_8h_source.html">Admin.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Admin:</div>
<div class="dyncontent">
<div class="center"><img src="class_admin__inherit__graph.png" border="0" usemap="#_admin_inherit__map" alt="Inheritance graph"/></div>
<map name="_admin_inherit__map" id="_admin_inherit__map">
<area shape="rect" id="node2" href="class_user.html" title="User" alt="" coords="11,80,62,107"/>
<area shape="rect" id="node3" href="class_person.html" title="Wrap for generic person personal info. " alt="" coords="5,5,68,32"/>
</map>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for Admin:</div>
<div class="dyncontent">
<div class="center"><img src="class_admin__coll__graph.png" border="0" usemap="#_admin_coll__map" alt="Collaboration graph"/></div>
<map name="_admin_coll__map" id="_admin_coll__map">
<area shape="rect" id="node2" href="class_user.html" title="User" alt="" coords="71,109,122,136"/>
<area shape="rect" id="node3" href="class_person.html" title="Wrap for generic person personal info. " alt="" coords="5,5,68,32"/>
<area shape="rect" id="node4" href="class_database.html" title="Database\&lt; Book \&gt;" alt="" coords="92,5,224,32"/>
</map>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:add5f3d47d70f73f496ec38e236e18f12"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#add5f3d47d70f73f496ec38e236e18f12">Admin</a> (std::string name, std::string surname, QDate date, std::string email, <a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&gt; *books, <a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&gt; *users)</td></tr>
<tr class="memdesc:add5f3d47d70f73f496ec38e236e18f12"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> New <a class="el" href="class_person.html" title="Wrap for generic person personal info. ">Person</a> with email and optional date of birth.  <a href="#add5f3d47d70f73f496ec38e236e18f12">More...</a><br /></td></tr>
<tr class="separator:add5f3d47d70f73f496ec38e236e18f12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7538bc53c81d7a23fcec717fe67d7368"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a7538bc53c81d7a23fcec717fe67d7368">Admin</a> (const <a class="el" href="class_admin.html">Admin</a> &amp;a)</td></tr>
<tr class="memdesc:a7538bc53c81d7a23fcec717fe67d7368"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> deep copy of admin.  <a href="#a7538bc53c81d7a23fcec717fe67d7368">More...</a><br /></td></tr>
<tr class="separator:a7538bc53c81d7a23fcec717fe67d7368"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a82d05c516ca5777ef81c97bf605d92cc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a82d05c516ca5777ef81c97bf605d92cc">Admin</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; u)</td></tr>
<tr class="memdesc:a82d05c516ca5777ef81c97bf605d92cc"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> make user an admin.  <a href="#a82d05c516ca5777ef81c97bf605d92cc">More...</a><br /></td></tr>
<tr class="separator:a82d05c516ca5777ef81c97bf605d92cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a815ad9d97b9f25b733b409faa38ea9dd"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a815ad9d97b9f25b733b409faa38ea9dd">Admin</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; u, <a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&gt; *books, <a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&gt; *users)</td></tr>
<tr class="memdesc:a815ad9d97b9f25b733b409faa38ea9dd"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> make user an admin.  <a href="#a815ad9d97b9f25b733b409faa38ea9dd">More...</a><br /></td></tr>
<tr class="separator:a815ad9d97b9f25b733b409faa38ea9dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8fb5fe72fb4e05d50980c13cdf3b779c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8fb5fe72fb4e05d50980c13cdf3b779c"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a8fb5fe72fb4e05d50980c13cdf3b779c">~Admin</a> ()</td></tr>
<tr class="memdesc:a8fb5fe72fb4e05d50980c13cdf3b779c"><td class="mdescLeft">&#160;</td><td class="mdescRight">~Admin Destroy admin fields (but not shared books library) <br /></td></tr>
<tr class="separator:a8fb5fe72fb4e05d50980c13cdf3b779c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a64c486c9db82942a3cf2b9591d43bc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a4a64c486c9db82942a3cf2b9591d43bc">addBook</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; book)</td></tr>
<tr class="memdesc:a4a64c486c9db82942a3cf2b9591d43bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">adds new book to library  <a href="#a4a64c486c9db82942a3cf2b9591d43bc">More...</a><br /></td></tr>
<tr class="separator:a4a64c486c9db82942a3cf2b9591d43bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab5abc30d4feddbe7c6ae34743378c995"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#ab5abc30d4feddbe7c6ae34743378c995">removeBook</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; book)</td></tr>
<tr class="memdesc:ab5abc30d4feddbe7c6ae34743378c995"><td class="mdescLeft">&#160;</td><td class="mdescRight">adds new book to library  <a href="#ab5abc30d4feddbe7c6ae34743378c995">More...</a><br /></td></tr>
<tr class="separator:ab5abc30d4feddbe7c6ae34743378c995"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19ccdf33fc763617f77c6ec7ccea46c3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a19ccdf33fc763617f77c6ec7ccea46c3">replaceBook</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; oldBook, <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; newBook)</td></tr>
<tr class="memdesc:a19ccdf33fc763617f77c6ec7ccea46c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">replaces old books with new books  <a href="#a19ccdf33fc763617f77c6ec7ccea46c3">More...</a><br /></td></tr>
<tr class="separator:a19ccdf33fc763617f77c6ec7ccea46c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abdb263f503e23f5ef2bbf140092b305e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#abdb263f503e23f5ef2bbf140092b305e">addUser</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; user)</td></tr>
<tr class="memdesc:abdb263f503e23f5ef2bbf140092b305e"><td class="mdescLeft">&#160;</td><td class="mdescRight">adds new user to library  <a href="#abdb263f503e23f5ef2bbf140092b305e">More...</a><br /></td></tr>
<tr class="separator:abdb263f503e23f5ef2bbf140092b305e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2cd28597301d7c6e3acc5923055b0956"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a2cd28597301d7c6e3acc5923055b0956">removeUser</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; user)</td></tr>
<tr class="memdesc:a2cd28597301d7c6e3acc5923055b0956"><td class="mdescLeft">&#160;</td><td class="mdescRight">adds new user to library  <a href="#a2cd28597301d7c6e3acc5923055b0956">More...</a><br /></td></tr>
<tr class="separator:a2cd28597301d7c6e3acc5923055b0956"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a800d579a5b22fdfc4e05ba595f46667f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a800d579a5b22fdfc4e05ba595f46667f">makeAdmin</a> (<a class="el" href="class_user.html">User</a> *u)</td></tr>
<tr class="memdesc:a800d579a5b22fdfc4e05ba595f46667f"><td class="mdescLeft">&#160;</td><td class="mdescRight">makes user an admin  <a href="#a800d579a5b22fdfc4e05ba595f46667f">More...</a><br /></td></tr>
<tr class="separator:a800d579a5b22fdfc4e05ba595f46667f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4e451f158e0c497042b9d8391e23c829"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_admin.html">Admin</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#a4e451f158e0c497042b9d8391e23c829">operator=</a> (const <a class="el" href="class_admin.html">Admin</a> &amp;a)</td></tr>
<tr class="memdesc:a4e451f158e0c497042b9d8391e23c829"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator = <a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> deep copy of person  <a href="#a4e451f158e0c497042b9d8391e23c829">More...</a><br /></td></tr>
<tr class="separator:a4e451f158e0c497042b9d8391e23c829"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_class_user"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_class_user')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="class_user.html">User</a></td></tr>
<tr class="memitem:ae78803d1d577c2450b50cff54bf9ec07 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#ae78803d1d577c2450b50cff54bf9ec07">User</a> (std::string name, std::string surname, QDate date, std::string email)</td></tr>
<tr class="memdesc:ae78803d1d577c2450b50cff54bf9ec07 inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_user.html">User</a> New <a class="el" href="class_person.html" title="Wrap for generic person personal info. ">Person</a> with email and optional date of birth.  <a href="#ae78803d1d577c2450b50cff54bf9ec07">More...</a><br /></td></tr>
<tr class="separator:ae78803d1d577c2450b50cff54bf9ec07 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99cadf8dd70a9dcc752b7f1df0af809d inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a99cadf8dd70a9dcc752b7f1df0af809d">User</a> (std::string email)</td></tr>
<tr class="separator:a99cadf8dd70a9dcc752b7f1df0af809d inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a018a343a483ee5d702fc11c3d6383ac7 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a018a343a483ee5d702fc11c3d6383ac7">User</a> (const <a class="el" href="class_user.html">User</a> &amp;u)</td></tr>
<tr class="memdesc:a018a343a483ee5d702fc11c3d6383ac7 inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_user.html">User</a> deep copy of user.  <a href="#a018a343a483ee5d702fc11c3d6383ac7">More...</a><br /></td></tr>
<tr class="separator:a018a343a483ee5d702fc11c3d6383ac7 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace19848c26b4b131c6f7b48d7b146ffc inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#ace19848c26b4b131c6f7b48d7b146ffc">isAdmin</a> ()</td></tr>
<tr class="memdesc:ace19848c26b4b131c6f7b48d7b146ffc inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight">isAdmin checks whether user is an admin  <a href="#ace19848c26b4b131c6f7b48d7b146ffc">More...</a><br /></td></tr>
<tr class="separator:ace19848c26b4b131c6f7b48d7b146ffc inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a691b2225590d655a5ffea2b03402e125 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a691b2225590d655a5ffea2b03402e125">reserveBook</a> (<a class="el" href="class_book.html">Book</a> *book)</td></tr>
<tr class="separator:a691b2225590d655a5ffea2b03402e125 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa194caf9ec2a069de06d7d0b388e6b5d inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#aa194caf9ec2a069de06d7d0b388e6b5d">returnBook</a> (<a class="el" href="class_book.html">Book</a> *book)</td></tr>
<tr class="separator:aa194caf9ec2a069de06d7d0b388e6b5d inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa01f3ad7431073992a545da9660fa3ad inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#aa01f3ad7431073992a545da9660fa3ad">isBookReservedByUser</a> (<a class="el" href="class_book.html">Book</a> book)</td></tr>
<tr class="separator:aa01f3ad7431073992a545da9660fa3ad inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb9a76bda3d20fb82db91855be66d620 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#adb9a76bda3d20fb82db91855be66d620">isBookInWishlist</a> (<a class="el" href="class_book.html">Book</a> book)</td></tr>
<tr class="separator:adb9a76bda3d20fb82db91855be66d620 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a003a00af12fe873041488375f8abdccb inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a003a00af12fe873041488375f8abdccb">setEmail</a> (std::string email)</td></tr>
<tr class="separator:a003a00af12fe873041488375f8abdccb inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9647677311d12cea36d96591f31237c6 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a9647677311d12cea36d96591f31237c6">addBookToWishList</a> (<a class="el" href="class_book.html">Book</a> book)</td></tr>
<tr class="memdesc:a9647677311d12cea36d96591f31237c6 inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight">appends book to list of books user wants to read  <a href="#a9647677311d12cea36d96591f31237c6">More...</a><br /></td></tr>
<tr class="separator:a9647677311d12cea36d96591f31237c6 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f821b3d4a692cf9f51439d428eedc65 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a1f821b3d4a692cf9f51439d428eedc65">removeBookFromWishList</a> (<a class="el" href="class_book.html">Book</a> book)</td></tr>
<tr class="memdesc:a1f821b3d4a692cf9f51439d428eedc65 inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight">removes book from list of books user wants to read  <a href="#a1f821b3d4a692cf9f51439d428eedc65">More...</a><br /></td></tr>
<tr class="separator:a1f821b3d4a692cf9f51439d428eedc65 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00601492ab5e28c33d67a0d49b432150 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a00601492ab5e28c33d67a0d49b432150">getEmail</a> () const </td></tr>
<tr class="memdesc:a00601492ab5e28c33d67a0d49b432150 inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight">gets user email  <a href="#a00601492ab5e28c33d67a0d49b432150">More...</a><br /></td></tr>
<tr class="separator:a00601492ab5e28c33d67a0d49b432150 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77b858ec6e7b02a3893613f9ba7fd95a inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a77b858ec6e7b02a3893613f9ba7fd95a">getWishList</a> () const </td></tr>
<tr class="separator:a77b858ec6e7b02a3893613f9ba7fd95a inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac60139fa8d8dd4804936ffcb8bfdca45 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#ac60139fa8d8dd4804936ffcb8bfdca45">getLoans</a> () const </td></tr>
<tr class="separator:ac60139fa8d8dd4804936ffcb8bfdca45 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2bedf75049198d6218bd77f6df897c99 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_user.html">User</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a2bedf75049198d6218bd77f6df897c99">operator=</a> (const <a class="el" href="class_user.html">User</a> &amp;u)</td></tr>
<tr class="memdesc:a2bedf75049198d6218bd77f6df897c99 inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator = <a class="el" href="class_user.html">User</a> deep copy of person  <a href="#a2bedf75049198d6218bd77f6df897c99">More...</a><br /></td></tr>
<tr class="separator:a2bedf75049198d6218bd77f6df897c99 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e787f019ae942181d625c94290d5972 inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#a2e787f019ae942181d625c94290d5972">operator==</a> (const <a class="el" href="class_user.html">User</a> &amp;other) const </td></tr>
<tr class="memdesc:a2e787f019ae942181d625c94290d5972 inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight">equals 2 users by comparing emails  <a href="#a2e787f019ae942181d625c94290d5972">More...</a><br /></td></tr>
<tr class="separator:a2e787f019ae942181d625c94290d5972 inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed9ecdccccc81a597b3e2aac099a9a2f inherit pub_methods_class_user"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_user.html#aed9ecdccccc81a597b3e2aac099a9a2f">operator!=</a> (const <a class="el" href="class_user.html">User</a> &amp;other) const </td></tr>
<tr class="memdesc:aed9ecdccccc81a597b3e2aac099a9a2f inherit pub_methods_class_user"><td class="mdescLeft">&#160;</td><td class="mdescRight">equals 2 users by comparing emails  <a href="#aed9ecdccccc81a597b3e2aac099a9a2f">More...</a><br /></td></tr>
<tr class="separator:aed9ecdccccc81a597b3e2aac099a9a2f inherit pub_methods_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_class_person"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_class_person')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="class_person.html">Person</a></td></tr>
<tr class="memitem:a27a7b19cdace6de9a04ce0d06fec7957 inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#a27a7b19cdace6de9a04ce0d06fec7957">Person</a> (std::string name, std::string surname, QDate date)</td></tr>
<tr class="memdesc:a27a7b19cdace6de9a04ce0d06fec7957 inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_person.html" title="Wrap for generic person personal info. ">Person</a> default constructor with name, surname and date of birth.  <a href="#a27a7b19cdace6de9a04ce0d06fec7957">More...</a><br /></td></tr>
<tr class="separator:a27a7b19cdace6de9a04ce0d06fec7957 inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a847845e2e214a89e790c584678f1ea97 inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#a847845e2e214a89e790c584678f1ea97">Person</a> (const <a class="el" href="class_person.html">Person</a> &amp;p)</td></tr>
<tr class="memdesc:a847845e2e214a89e790c584678f1ea97 inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_person.html" title="Wrap for generic person personal info. ">Person</a> deep copy of person.  <a href="#a847845e2e214a89e790c584678f1ea97">More...</a><br /></td></tr>
<tr class="separator:a847845e2e214a89e790c584678f1ea97 inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae046bc90711195d83799f81e096ad503 inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_person.html">Person</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#ae046bc90711195d83799f81e096ad503">operator=</a> (const <a class="el" href="class_person.html">Person</a> &amp;p)</td></tr>
<tr class="memdesc:ae046bc90711195d83799f81e096ad503 inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator = <a class="el" href="class_person.html" title="Wrap for generic person personal info. ">Person</a> deep copy of person  <a href="#ae046bc90711195d83799f81e096ad503">More...</a><br /></td></tr>
<tr class="separator:ae046bc90711195d83799f81e096ad503 inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a700ffd693321c5fe6880262acf43d4da inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a700ffd693321c5fe6880262acf43d4da"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#a700ffd693321c5fe6880262acf43d4da">~Person</a> ()</td></tr>
<tr class="memdesc:a700ffd693321c5fe6880262acf43d4da inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">~Person Destroy person fields <br /></td></tr>
<tr class="separator:a700ffd693321c5fe6880262acf43d4da inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c6a2bfb43c790bc8260933bd847a582 inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#a7c6a2bfb43c790bc8260933bd847a582">operator==</a> (const <a class="el" href="class_person.html">Person</a> &amp;other) const </td></tr>
<tr class="memdesc:a7c6a2bfb43c790bc8260933bd847a582 inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual because there can be 2 persons with same name and surname and date of birth  <a href="#a7c6a2bfb43c790bc8260933bd847a582">More...</a><br /></td></tr>
<tr class="separator:a7c6a2bfb43c790bc8260933bd847a582 inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4f47029402c26c3643d23ef04695bb1 inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#ae4f47029402c26c3643d23ef04695bb1">operator!=</a> (const <a class="el" href="class_person.html">Person</a> &amp;other) const </td></tr>
<tr class="memdesc:ae4f47029402c26c3643d23ef04695bb1 inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual because there can be 2 persons with same name and surname and date of birth  <a href="#ae4f47029402c26c3643d23ef04695bb1">More...</a><br /></td></tr>
<tr class="separator:ae4f47029402c26c3643d23ef04695bb1 inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6e438f456d3ae6f5b477931c0a6aeba inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#ad6e438f456d3ae6f5b477931c0a6aeba">setName</a> (std::string name)</td></tr>
<tr class="memdesc:ad6e438f456d3ae6f5b477931c0a6aeba inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">set new name  <a href="#ad6e438f456d3ae6f5b477931c0a6aeba">More...</a><br /></td></tr>
<tr class="separator:ad6e438f456d3ae6f5b477931c0a6aeba inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6a9ce78af39382fbab39f64319c7cde inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#af6a9ce78af39382fbab39f64319c7cde">setSurname</a> (std::string surname)</td></tr>
<tr class="memdesc:af6a9ce78af39382fbab39f64319c7cde inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">set new surname  <a href="#af6a9ce78af39382fbab39f64319c7cde">More...</a><br /></td></tr>
<tr class="separator:af6a9ce78af39382fbab39f64319c7cde inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a172e5a16b36e2aa9dfec68b289e1747b inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#a172e5a16b36e2aa9dfec68b289e1747b">setDateOfBirth</a> (QDate dateOfBirth)</td></tr>
<tr class="memdesc:a172e5a16b36e2aa9dfec68b289e1747b inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">set new date of birth  <a href="#a172e5a16b36e2aa9dfec68b289e1747b">More...</a><br /></td></tr>
<tr class="separator:a172e5a16b36e2aa9dfec68b289e1747b inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0c7e40e02bfa616e17a0c332dd248eb inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#ac0c7e40e02bfa616e17a0c332dd248eb">getName</a> () const </td></tr>
<tr class="memdesc:ac0c7e40e02bfa616e17a0c332dd248eb inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">gets name  <a href="#ac0c7e40e02bfa616e17a0c332dd248eb">More...</a><br /></td></tr>
<tr class="separator:ac0c7e40e02bfa616e17a0c332dd248eb inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f24e2654e52db9c1f1c368a13135ae1 inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#a7f24e2654e52db9c1f1c368a13135ae1">getSurname</a> () const </td></tr>
<tr class="memdesc:a7f24e2654e52db9c1f1c368a13135ae1 inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">gets surname  <a href="#a7f24e2654e52db9c1f1c368a13135ae1">More...</a><br /></td></tr>
<tr class="separator:a7f24e2654e52db9c1f1c368a13135ae1 inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6958ae5c891dee615a0802bbefd7bc24 inherit pub_methods_class_person"><td class="memItemLeft" align="right" valign="top">QDate&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_person.html#a6958ae5c891dee615a0802bbefd7bc24">getDateOfBirth</a> () const </td></tr>
<tr class="memdesc:a6958ae5c891dee615a0802bbefd7bc24 inherit pub_methods_class_person"><td class="mdescLeft">&#160;</td><td class="mdescRight">gets date of birth  <a href="#a6958ae5c891dee615a0802bbefd7bc24">More...</a><br /></td></tr>
<tr class="separator:a6958ae5c891dee615a0802bbefd7bc24 inherit pub_methods_class_person"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:ab50d4206f7748ecb4dad7c3734322c97"><td class="memItemLeft" align="right" valign="top">std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#ab50d4206f7748ecb4dad7c3734322c97">operator&lt;&lt;</a> (std::ostream &amp;out, const <a class="el" href="class_admin.html">Admin</a> &amp;admin)</td></tr>
<tr class="memdesc:ab50d4206f7748ecb4dad7c3734322c97"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator &lt;&lt; printer  <a href="#ab50d4206f7748ecb4dad7c3734322c97">More...</a><br /></td></tr>
<tr class="separator:ab50d4206f7748ecb4dad7c3734322c97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec88e857e4a3328db47ab3f48998bb34"><td class="memItemLeft" align="right" valign="top">std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_admin.html#aec88e857e4a3328db47ab3f48998bb34">operator&lt;&lt;</a> (std::ostream &amp;out, const <a class="el" href="class_admin.html">Admin</a> *admin)</td></tr>
<tr class="memdesc:aec88e857e4a3328db47ab3f48998bb34"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator &lt;&lt; printer  <a href="#aec88e857e4a3328db47ab3f48998bb34">More...</a><br /></td></tr>
<tr class="separator:aec88e857e4a3328db47ab3f48998bb34"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_attribs_class_user"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_class_user')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="class_user.html">User</a></td></tr>
<tr class="memitem:aa8a642e5ba1f9ae343354cb649f753db inherit pro_attribs_class_user"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa8a642e5ba1f9ae343354cb649f753db"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>amIAdmin</b> = false</td></tr>
<tr class="separator:aa8a642e5ba1f9ae343354cb649f753db inherit pro_attribs_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac35b7c63228119cb91acdbd7ed32b8cb inherit pro_attribs_class_user"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac35b7c63228119cb91acdbd7ed32b8cb"></a>
std::string&#160;</td><td class="memItemRight" valign="bottom"><b>email</b></td></tr>
<tr class="separator:ac35b7c63228119cb91acdbd7ed32b8cb inherit pro_attribs_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a557a69cdb6f9cf249c15c991535016b5 inherit pro_attribs_class_user"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a557a69cdb6f9cf249c15c991535016b5"></a>
<a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>wishList</b></td></tr>
<tr class="separator:a557a69cdb6f9cf249c15c991535016b5 inherit pro_attribs_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d118d66c1851a40670a9decf2637eee inherit pro_attribs_class_user"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0d118d66c1851a40670a9decf2637eee"></a>
<a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>loans</b></td></tr>
<tr class="separator:a0d118d66c1851a40670a9decf2637eee inherit pro_attribs_class_user"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A library user who is also an admin (i.e can manage books of library) </p>
<p>Copyright 2016-2017 Stefano Fogarollo</p>
<p>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</p>
<p><a href="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</a></p>
<p>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="add5f3d47d70f73f496ec38e236e18f12"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Admin::Admin </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>surname</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">QDate&#160;</td>
          <td class="paramname"><em>date</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>email</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&gt; *&#160;</td>
          <td class="paramname"><em>books</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&gt; *&#160;</td>
          <td class="paramname"><em>users</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> New <a class="el" href="class_person.html" title="Wrap for generic person personal info. ">Person</a> with email and optional date of birth. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>name of person </td></tr>
    <tr><td class="paramname">surname</td><td>surname of person </td></tr>
    <tr><td class="paramname">date</td><td>date of birth of person </td></tr>
    <tr><td class="paramname">email</td><td>email to register user </td></tr>
    <tr><td class="paramname">books</td><td>library books to manage</td></tr>
  </table>
  </dd>
</dl>
<p>Copyright 2016-2017 Stefano Fogarollo</p>
<p>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</p>
<p><a href="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</a></p>
<p>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </p>

</div>
</div>
<a class="anchor" id="a7538bc53c81d7a23fcec717fe67d7368"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Admin::Admin </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_admin.html">Admin</a> &amp;&#160;</td>
          <td class="paramname"><em>a</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> deep copy of admin. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>admin to copy </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a82d05c516ca5777ef81c97bf605d92cc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Admin::Admin </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>u</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> make user an admin. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">u</td><td>user to make admin </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a815ad9d97b9f25b733b409faa38ea9dd"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Admin::Admin </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>u</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&gt; *&#160;</td>
          <td class="paramname"><em>books</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&gt; *&#160;</td>
          <td class="paramname"><em>users</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> make user an admin. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">u</td><td>user to make admin </td></tr>
    <tr><td class="paramname">books</td><td>books of admin to manage </td></tr>
    <tr><td class="paramname">users</td><td>users of admin to manage </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a4a64c486c9db82942a3cf2b9591d43bc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Admin::addBook </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>book</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adds new book to library </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">book</td><td>new book to add </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abdb263f503e23f5ef2bbf140092b305e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Admin::addUser </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>user</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adds new user to library </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">book</td><td>new user to add </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a800d579a5b22fdfc4e05ba595f46667f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; Admin::makeAdmin </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_user.html">User</a> *&#160;</td>
          <td class="paramname"><em>u</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>makes user an admin </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">u</td><td>user to make admin </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>admin </dd></dl>

</div>
</div>
<a class="anchor" id="a4e451f158e0c497042b9d8391e23c829"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_admin.html">Admin</a> &amp; Admin::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_admin.html">Admin</a> &amp;&#160;</td>
          <td class="paramname"><em>a</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>operator = <a class="el" href="class_admin.html" title="A library user who is also an admin (i.e can manage books of library) ">Admin</a> deep copy of person </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>admin to copy </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>deep copy of admin </dd></dl>

</div>
</div>
<a class="anchor" id="ab5abc30d4feddbe7c6ae34743378c995"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Admin::removeBook </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>book</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adds new book to library </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">book</td><td>new book to add </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2cd28597301d7c6e3acc5923055b0956"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Admin::removeUser </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>user</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adds new user to library </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">book</td><td>new user to add </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a19ccdf33fc763617f77c6ec7ccea46c3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Admin::replaceBook </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>oldBook</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>newBook</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>replaces old books with new books </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">oldBook</td><td>book to replace with new </td></tr>
    <tr><td class="paramname">newBook</td><td>new book </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a class="anchor" id="ab50d4206f7748ecb4dad7c3734322c97"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="class_admin.html">Admin</a> &amp;&#160;</td>
          <td class="paramname"><em>admin</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>operator &lt;&lt; printer </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">out</td><td>stream </td></tr>
    <tr><td class="paramname">object</td><td>to print </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>print object </dd></dl>

</div>
</div>
<a class="anchor" id="aec88e857e4a3328db47ab3f48998bb34"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="class_admin.html">Admin</a> *&#160;</td>
          <td class="paramname"><em>admin</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>operator &lt;&lt; printer </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">out</td><td>stream </td></tr>
    <tr><td class="paramname">object</td><td>to print </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>print object </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>models/People/Admin/<a class="el" href="_admin_8h_source.html">Admin.h</a></li>
<li>models/People/Admin/Admin.cpp</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_admin.html">Admin</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
